/*
 *      Copyright (c) 2018-2028, Chill Zhuang All rights reserved.
 *
 *  Redistribution and use in source and binary forms, with or without
 *  modification, are permitted provided that the following conditions are met:
 *
 *  Redistributions of source code must retain the above copyright notice,
 *  this list of conditions and the following disclaimer.
 *  Redistributions in binary form must reproduce the above copyright
 *  notice, this list of conditions and the following disclaimer in the
 *  documentation and/or other materials provided with the distribution.
 *  Neither the name of the dreamlu.net developer nor the names of its
 *  contributors may be used to endorse or promote products derived from
 *  this software without specific prior written permission.
 *  Author: Chill 庄骞 (smallchill@163.com)
 */
package org.springblade.modules.pl.productModel.controller;

import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import com.github.xiaoymin.knife4j.annotations.ApiOperationSupport;
import lombok.AllArgsConstructor;
import javax.validation.Valid;

import org.springblade.core.secure.BladeUser;
import org.springblade.core.mp.support.Condition;
import org.springblade.core.mp.support.Query;
import org.springblade.core.secure.utils.AuthUtil;
import org.springblade.core.tool.api.R;
import org.springblade.core.tool.utils.Func;
import org.springblade.modules.pl.client.entity.ClientEntity;
import org.springblade.modules.pl.equipment.entity.EquipmentEntity;
import org.springframework.web.bind.annotation.*;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import org.springblade.modules.pl.productModel.entity.ProductModelEntity;
import org.springblade.modules.pl.productModel.vo.ProductModelVO;
import org.springblade.modules.pl.productModel.excel.ProductModelExcel;
import org.springblade.modules.pl.productModel.wrapper.ProductModelWrapper;
import org.springblade.modules.pl.productModel.service.IProductModelService;
import org.springblade.core.boot.ctrl.BladeController;
import org.springblade.core.tool.utils.DateUtil;
import org.springblade.core.excel.util.ExcelUtil;
import org.springblade.core.tool.constant.BladeConstant;
import springfox.documentation.annotations.ApiIgnore;
import java.util.Map;
import java.util.List;
import javax.servlet.http.HttpServletResponse;

/**
 * 产品型号表 控制器
 *
 * @author BladeX
 * @since 2023-12-07
 */
@RestController
@AllArgsConstructor
@RequestMapping("pl-productModel/productModel")
@Api(value = "产品型号表", tags = "产品型号表接口")
public class ProductModelController extends BladeController {

	private final IProductModelService productModelService;

	/**
	 * 产品型号表 详情
	 */
	@GetMapping("/detail")
	@ApiOperationSupport(order = 1)
	@ApiOperation(value = "详情", notes = "传入productModel")
	public R<ProductModelVO> detail(ProductModelEntity productModel) {
		ProductModelEntity detail = productModelService.getOne(Condition.getQueryWrapper(productModel));
		return R.data(ProductModelWrapper.build().entityVO(detail));
	}
	/**
	 * 产品型号表 分页
	 */
	@GetMapping("/list")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "分页", notes = "传入productModel")
	public R<IPage<ProductModelVO>> list(@ApiIgnore @RequestParam Map<String, Object> productModel, Query query) {
		query.setDescs("create_time");
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			productModel.put("factory_id",user.getFactoryId());
		}
		IPage<ProductModelEntity> pages = productModelService.page(Condition.getPage(query), Condition.getQueryWrapper(productModel, ProductModelEntity.class));
		return R.data(ProductModelWrapper.build().pageVO(pages));
	}

	/**
	 * 产品型号表 自定义分页
	 */
	@GetMapping("/page")
	@ApiOperationSupport(order = 3)
	@ApiOperation(value = "分页", notes = "传入productModel")
	public R<IPage<ProductModelVO>> page(ProductModelVO productModel, Query query) {
		IPage<ProductModelVO> pages = productModelService.selectProductModelPage(Condition.getPage(query), productModel);
		return R.data(pages);
	}

	/**
	 * 产品型号表 新增
	 */
	@PostMapping("/save")
	@ApiOperationSupport(order = 4)
	@ApiOperation(value = "新增", notes = "传入productModel")
	public R save(@Valid @RequestBody ProductModelEntity productModel) {
		return R.status(productModelService.save(productModel));
	}

	/**
	 * 产品型号表 修改
	 */
	@PostMapping("/update")
	@ApiOperationSupport(order = 5)
	@ApiOperation(value = "修改", notes = "传入productModel")
	public R update(@Valid @RequestBody ProductModelEntity productModel) {
		return R.status(productModelService.updateById(productModel));
	}

	/**
	 * 产品型号表 新增或修改
	 */
	@PostMapping("/submit")
	@ApiOperationSupport(order = 6)
	@ApiOperation(value = "新增或修改", notes = "传入productModel")
	public R submit(@Valid @RequestBody ProductModelEntity productModel) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			productModel.setFactoryId(user.getFactoryId());
		}
		long count = productModelService.count(Wrappers.<ProductModelEntity>lambdaQuery().eq(ProductModelEntity::getProductSpec,productModel.getProductSpec()).ne(productModel.getId()!=null,ProductModelEntity::getId,productModel.getId()));
		if(count>0){
			return R.fail("产品规格已存在");
		}
		return R.status(productModelService.saveOrUpdate(productModel));
	}

	/**
	 * 产品型号表 删除
	 */
	@PostMapping("/remove")
	@ApiOperationSupport(order = 7)
	@ApiOperation(value = "逻辑删除", notes = "传入ids")
	public R remove(@ApiParam(value = "主键集合", required = true) @RequestParam String ids) {
		return R.status(productModelService.deleteLogic(Func.toLongList(ids)));
	}


	/**
	 * 导出数据
	 */
	@GetMapping("/export-productModel")
	@ApiOperationSupport(order = 9)
	@ApiOperation(value = "导出数据", notes = "传入productModel")
	public void exportProductModel(@ApiIgnore @RequestParam Map<String, Object> productModel, BladeUser bladeUser, HttpServletResponse response) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			productModel.put("factory_id",user.getFactoryId());
		}
		QueryWrapper<ProductModelEntity> queryWrapper = Condition.getQueryWrapper(productModel, ProductModelEntity.class);
		//if (!AuthUtil.isAdministrator()) {
		//	queryWrapper.lambda().eq(ProductModel::getTenantId, bladeUser.getTenantId());
		//}
		queryWrapper.lambda().eq(ProductModelEntity::getIsDeleted, BladeConstant.DB_NOT_DELETED);
		List<ProductModelExcel> list = productModelService.exportProductModel(queryWrapper);
		ExcelUtil.export(response, "产品型号表数据" + DateUtil.time(), "产品型号表数据表", list, ProductModelExcel.class);
	}


	/**
	 * 产品型号表 下拉框
	 */
	@GetMapping("/select")
	@ApiOperationSupport(order = 2)
	@ApiOperation(value = "下拉框", notes = "传入factory")
	public R<List<ProductModelEntity>> select(ProductModelEntity productModel, Query query) {
		BladeUser user = AuthUtil.getUser();
		if(user.getUserCategory()==2){
			productModel.setFactoryId(user.getFactoryId());
		}
		List<ProductModelEntity> list = productModelService.list(Condition.getQueryWrapper(productModel));
		return R.data(list);
	}

}
